﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;

namespace SelectedItemsBindingDemo
{
    public class PersonModel : INotifyPropertyChanged
    {
        private ObservableCollection<object> _selectedItems; 
        public ObservableCollection<object> SelectedItems
        {
            get
            {
                return _selectedItems;
            }
            set
            {
                _selectedItems = value;
                RaisePropertyChanged("SelectedItems");
            }
        }

        private string _summary;
        public string Summary
        {
            get
            {
                return _summary;
            }
            private set
            {
                _summary = value;
                RaisePropertyChanged("Summary");
            }
        }
        public PersonModel()
        {
            this.PersonDetails = Getsource();

            SelectedItems = new ObservableCollection<object>();
            SelectedItems.Add(PersonDetails[2]);
            SelectedItems.Add(PersonDetails[4]);
            SelectedItems.Add(PersonDetails[6]);
            SelectedItems.Add(PersonDetails[9]);
        }

        private ObservableCollection<Person> _persondetails;
        public ObservableCollection<Person> PersonDetails
        {
            get { return _persondetails; }
            set
            { _persondetails = value;
                RaisePropertyChanged("PersonDetails");
            }
        }
        private ObservableCollection<Person> Getsource()
        {
            ObservableCollection<Person> items = new ObservableCollection<Person>();
            if (items != null)
            {
                items.Add(new Person() { FirstName = "Sean", LastName = "Jacobson", Age = 23, Salary = 1999, GrandTotal = 898908, PF = 8798798, ESI = 2498, Tax = 4298, Income = 2389, Company = "SF", Loss = 880, Profit = 880980, TrunOver = 48193891, Incometax = 234113, Expense = 98798798, Payslip = 8789, Unitprice = 987, Stockdetails = "Avial", StockCount = 8989, Count = 43 });
                items.Add(new Person() { FirstName = "Srithar", LastName = "Phyllis", Age = 24, Salary = 12349, GrandTotal = 234923408, PF = 8798798, ESI = 423598, Tax = 568, Income = 289, Company = "WP", Loss = 450, Profit = 54580, TrunOver = 28193891, Incometax = 2113, Expense = 1798798, Payslip = 68789, Unitprice = 8798, Stockdetails = "Avial", StockCount = 4389, Count = 83 });
                items.Add(new Person() { FirstName = "Marvin", LastName = "Allen", Age = 26, Salary = 123499, GrandTotal = 123495508, PF = 88798, ESI = 345348, Tax = 55398, Income = 4489, Company = "TC", Loss = 250, Profit = 234423, TrunOver = 2448193891, Incometax = 78124, Expense = 9879814, Payslip = 458789, Unitprice = 798, Stockdetails = "Avial", StockCount = 8966, Count = 89 });
                items.Add(new Person() { FirstName = "Michael", LastName = "Allen", Age = 23, Salary = 1999, GrandTotal = 898908, PF = 8798798, ESI = 2498, Tax = 4298, Income = 2389, Company = "SF", Loss = 880, Profit = 880980, TrunOver = 48193891, Incometax = 234113, Expense = 98798798, Payslip = 8789, Unitprice = 987, Stockdetails = "Avial", StockCount = 8989, Count = 43 });
                items.Add(new Person() { FirstName = "Cecil", LastName = "Allison", Age = 24, Salary = 12349, GrandTotal = 234923408, PF = 8798798, ESI = 423598, Tax = 568, Income = 289, Company = "WP", Loss = 450, Profit = 54580, TrunOver = 28193891, Incometax = 2113, Expense = 1798798, Payslip = 68789, Unitprice = 8798, Stockdetails = "Avial", StockCount = 4389, Count = 83 });
                items.Add(new Person() { FirstName = "Oscar", LastName = "Alpuerto", Age = 26, Salary = 123499, GrandTotal = 123495508, PF = 88798, ESI = 345348, Tax = 55398, Income = 4489, Company = "TC", Loss = 250, Profit = 234423, TrunOver = 2448193891, Incometax = 78124, Expense = 9879814, Payslip = 458789, Unitprice = 798, Stockdetails = "Avial", StockCount = 8966, Count = 89 });
                items.Add(new Person() { FirstName = "Sandra", LastName = "Altamirano", Age = 23, Salary = 1999, GrandTotal = 898908, PF = 8798798, ESI = 2498, Tax = 4298, Income = 2389, Company = "SF", Loss = 880, Profit = 880980, TrunOver = 48193891, Incometax = 234113, Expense = 98798798, Payslip = 8789, Unitprice = 987, Stockdetails = "Avial", StockCount = 8989, Count = 43 });
                items.Add(new Person() { FirstName = "Selena", LastName = "Alvarad", Age = 24, Salary = 12349, GrandTotal = 234923408, PF = 8798798, ESI = 423598, Tax = 568, Income = 289, Company = "WP", Loss = 450, Profit = 54580, TrunOver = 28193891, Incometax = 2113, Expense = 1798798, Payslip = 68789, Unitprice = 8798, Stockdetails = "Avial", StockCount = 4389, Count = 83 });
                items.Add(new Person() { FirstName = "Emilio", LastName = "Alvaro", Age = 26, Salary = 123499, GrandTotal = 123495508, PF = 88798, ESI = 345348, Tax = 55398, Income = 4489, Company = "TC", Loss = 250, Profit = 234423, TrunOver = 2448193891, Incometax = 78124, Expense = 9879814, Payslip = 458789, Unitprice = 798, Stockdetails = "Avial", StockCount = 8966, Count = 89 });
                items.Add(new Person() { FirstName = "Maxwell", LastName = "Amland", Age = 23, Salary = 1999, GrandTotal = 898908, PF = 8798798, ESI = 2498, Tax = 4298, Income = 2389, Company = "SF", Loss = 880, Profit = 880980, TrunOver = 48193891, Incometax = 234113, Expense = 98798798, Payslip = 8789, Unitprice = 987, Stockdetails = "Avial", StockCount = 8989, Count = 43 });
                items.Add(new Person() { FirstName = "Ramona", LastName = "Antrim", Age = 24, Salary = 12349, GrandTotal = 234923408, PF = 8798798, ESI = 423598, Tax = 568, Income = 289, Company = "WP", Loss = 450, Profit = 54580, TrunOver = 28193891, Incometax = 2113, Expense = 1798798, Payslip = 68789, Unitprice = 8798, Stockdetails = "Avial", StockCount = 4389, Count = 83 });
                items.Add(new Person() { FirstName = "Sabria", LastName = "Appelbaum", Age = 26, Salary = 123499, GrandTotal = 123495508, PF = 88798, ESI = 345348, Tax = 55398, Income = 4489, Company = "TC", Loss = 250, Profit = 234423, TrunOver = 2448193891, Incometax = 78124, Expense = 9879814, Payslip = 458789, Unitprice = 798, Stockdetails = "Avial", StockCount = 8966, Count = 89 });
                items.Add(new Person() { FirstName = "Hannah", LastName = "Arakawa", Age = 23, Salary = 1999, GrandTotal = 898908, PF = 8798798, ESI = 2498, Tax = 4298, Income = 2389, Company = "SF", Loss = 880, Profit = 880980, TrunOver = 48193891, Incometax = 234113, Expense = 98798798, Payslip = 8789, Unitprice = 987, Stockdetails = "Avial", StockCount = 8989, Count = 43 });
                items.Add(new Person() { FirstName = "Kyley", LastName = "Arbelaez", Age = 24, Salary = 12349, GrandTotal = 234923408, PF = 8798798, ESI = 423598, Tax = 568, Income = 289, Company = "WP", Loss = 450, Profit = 54580, TrunOver = 28193891, Incometax = 2113, Expense = 1798798, Payslip = 68789, Unitprice = 8798, Stockdetails = "Avial", StockCount = 4389, Count = 83 });
                items.Add(new Person() { FirstName = "Thomas", LastName = "Armstrong", Age = 26, Salary = 123499, GrandTotal = 123495508, PF = 88798, ESI = 345348, Tax = 55398, Income = 4489, Company = "TC", Loss = 250, Profit = 234423, TrunOver = 2448193891, Incometax = 78124, Expense = 9879814, Payslip = 458789, Unitprice = 798, Stockdetails = "Avial", StockCount = 8966, Count = 89 });
                items.Add(new Person() { FirstName = "Chris", LastName = "Ashton", Age = 23, Salary = 1999, GrandTotal = 898908, PF = 8798798, ESI = 2498, Tax = 4298, Income = 2389, Company = "SF", Loss = 880, Profit = 880980, TrunOver = 48193891, Incometax = 234113, Expense = 98798798, Payslip = 8789, Unitprice = 987, Stockdetails = "Avial", StockCount = 8989, Count = 43 });
            }
            return items;            
        }
       
        public event PropertyChangedEventHandler PropertyChanged;
        public void RaisePropertyChanged(string propName)
        {
            if (this.PropertyChanged != null)
                this.PropertyChanged(this, new PropertyChangedEventArgs(propName));
        }
    }
}
