﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace SelectedItemsBindingDemo
{
    public partial class MainWindow : Window
    {
        ObservableCollection<object> selectedItemsCollection = new ObservableCollection<object>();
        PersonModel viewModel;
        public MainWindow()
        {
            InitializeComponent();
            viewModel = this.DataContext as PersonModel;
            selectedItemsCollection.Add(viewModel.PersonDetails[1]);
            selectedItemsCollection.Add(viewModel.PersonDetails[2]);
            selectedItemsCollection.Add(viewModel.PersonDetails[3]);
            selectedItemsCollection.Add(viewModel.PersonDetails[4]);
            this.dataGrid.SelectedItems.CollectionChanged += SelectedItems_CollectionChanged;
        }

        private void SelectedItems_CollectionChanged(object sender, System.Collections.Specialized.NotifyCollectionChangedEventArgs e)
        {
            MessageBox.Show("\n SelectedItems changed");
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            MessageBox.Show("\n SelectedItems count:" + viewModel.SelectedItems.Count.ToString());
        }

        private void Button1_Click(object sender, RoutedEventArgs e)
        {
            viewModel.SelectedItems = selectedItemsCollection;
        }
    }
}
